# AC3D
# Copyright (c) 2016, Inivis Limited. All rights reserved.

# current object - properties dialog


proc set_object_data { string } {
#update the global variable for object data and change display if needed
global current_object_data UI

#puts "    updating object prop"
#puts "    got object data $string"

	set current_object_data $string
	if [winfo exists .d] {
		$UI(prop_object_data) delete 0.0 end
		$UI(prop_object_data) insert end $current_object_data
	}
}
 

 


#ac3d add_pref window_geom_object_properties ""

proc create_object_properties_panel { parent } {
global current_object_data current_crease_angle UI CURRENT gridr GRIDROW
global ac_platform prefs_subdiv_max_level

#puts "display_object_data $current_object_data"

	ac_label $parent.object_data_message -text "Object Properties:" -justify left
	pack $parent.object_data_message -side top -fill x -anchor w

	set UI(object_data_message) $parent.object_data_message

set top $parent

	############################

	set UI(object_properties_frame) [ac_frame $top.prop -borderwidth 5]
	pack $UI(object_properties_frame) -side top -fill x 
	set propparent $UI(object_properties_frame)

	set UI(object_properties_frame2) [ac_frame $top.prop2]
	pack $UI(object_properties_frame2) -side top -fill x
	set propparent2 $UI(object_properties_frame2)

	# init row count for parent (incremented when new attributes are added
	set GRIDROW($propparent) 0
	set GRIDROW($propparent2) 0

grid columnconfigure $propparent 1 -weight 1
grid columnconfigure $propparent2 1 -weight 1


	#object name
	set UI(prop_object_name) [ ac_create_pair_label_entry $propparent  current_object_name "Name" "name of the current object.\nit can also be changed on the control panel" ]

	bind $UI(prop_object_name) <KeyRelease> {
		ac3d set_current_object_name $current_object_name
		}

	#object url
	set UI(prop_object_url) [ ac_create_pair_label_entry $propparent current_object_url "URL"  "If there is a URL present, then the exported VRML object will have an anchor/link to it"]

	bind $UI(prop_object_url) <KeyRelease> {
		ac3d set_current_object_url $current_object_url
		}

	# object centre
	# the command to execute when return is pressed in a field
	set setloc { ac3d entity_set_value $CURRENT(object) "loc" "$CURRENT(loc_x) $CURRENT(loc_y) $CURRENT(loc_z)" ; ac3d redraw_all}

	set UI(current_loc_x) [ ac_create_pair_label_entry_float $propparent  CURRENT(loc_x) "Loc x" "object centre x" "" $setloc ]
	set UI(current_loc_y) [ ac_create_pair_label_entry_float $propparent  CURRENT(loc_y) "Loc y" "object centre y" "" $setloc ]
	set UI(current_loc_z) [ ac_create_pair_label_entry_float $propparent  CURRENT(loc_z) "Loc z" "object centre z" "" $setloc ]

#	bind $UI(current_loc_x) <Return> $setloc
#	bind $UI(current_loc_y) <Return> $setloc
#	bind $UI(current_loc_z) <Return> $setloc


	set setshowname { ac3d entity_set_value $CURRENT(object) "showname" "$CURRENT(showname)" ; ac3d redraw_all}

	set UI(current_showname) [ ac_create_pair_label_bool $propparent  CURRENT(showname) "Show name" "show object name?" $setshowname ]



	# subdivision level
	set setsubdiv { ac3d object_set_subdivision_level $CURRENT(object) "$CURRENT(subdiv_level)"}

	set UI(current_subdiv_level) [ ac_create_pair_label_spinbox $propparent CURRENT(subdiv_level)  "Subdiv preview" \
		"Subdivision level.\nEach subdivision level will (more than) quadruple the number of surfaces.\nConvert object to the actual subdivided polygons with Object->Commit-Subdivision." \
		2 0 $prefs_subdiv_max_level $setsubdiv]


	##############################

	# CREASE ANGLE
	set setcreaseangle {
		set co [ ac3d get_current_object]
		ac3d entity_set_value $co "crease" $CURRENT(crease_angle)
		ac3d object_calc_normals $co
		ac3d redraw_all
	}

	
	# although it's float, round it to int
	# not defined yet - set CURRENT(crease_angle) [expr int($CURRENT(crease_angle)) ]

	set CURRENT(crease_angle) 45
	set UI(prop_crease_button) [ ac_create_pair_int_scale $propparent CURRENT(crease_angle) "Crease angle"  "Crease angle - if the angle between two surfaces in the object is less than the specified angle,\nthey will be drawn with a hard edge. (Surface-type FLAT forces flat shading)"  "" 0 180 ]
	set p [winfo parent $UI(prop_crease_button)]
	ac_button $p.b -text "Apply" -command $setcreaseangle
	pack $p.b -side left


if {1} {
	ac_label $propparent.object_data_label -text "Object data text:"
	add_balloon $propparent.object_data_label "Object data text - saved with object (in .ac files)\ninserted in some output formats"
	grid $propparent.object_data_label

	set UI(object_data_frame) $top.f
	set UI(prop_object_data) [ ac_create_scrolled_text $UI(object_data_frame) 40 5 ]
	pack $UI(object_data_frame) -fill both -expand 1
	bind $UI(prop_object_data) <KeyRelease> {
		ac3d set_current_object_data  [$UI(prop_object_data) get 0.0 end-1c]
		}
}



	# make sure that the fields are disabled if they need to be:
	sync_ui

	# fill in the fields
#	 display_object_data

}


# this shoudl actually be called dialog_object_properties but we leave history alone here
proc edit_dive_data {} {

	ac_toplevel_with_close .d "Object Properties" create_object_properties_panel
}






proc get_object_data {} {
# put the text from the text widget into the tcl variable UI
	 global current_object_data

	if { [winfo exists .d] } {
		set current_object_data [$UI(prop_object_data) get 0.0 end-1c]
	}
}


proc disable_object_data {} {
global current_object_url
global current_object_name
global current_object_data
global UI



	set_sensitive FALSE  $UI(current_object_name_entry)
	set current_object_url ""
	set current_object_name ""
	set_object_data ""
	catch { $UI(object_data_message) configure -text "Select a single object to view/edit properties"}

	if { [winfo exists .d] } {
		pack forget $UI(object_properties_frame) $UI(object_properties_frame2) $UI(object_data_frame)
		set_sensitive FALSE $UI(prop_object_data) $UI(prop_object_name) $UI(prop_object_url)
#		set_sensitive FALSE $UI(prop_crease_scale) $UI(prop_crease_button)
	}

	

}

proc enable_object_data {} {
# should only be called when one object is selcted
global current_object_url
global current_object_name
global current_object_data current_crease_angle
global UI
global CURRENT

#puts "enable object data"



	set_sensitive TRUE	$UI(current_object_name_entry)

	set ob [ac3d get_selected_objects]
	set current_object_name  [ac3d object_get_name $ob]


#puts "REFRESHING CURRENT"

	# if properties window exists - check the object type and enable/disable accordingly
	if { [winfo exists .d] } {

		if { ![winfo exists .d] } {
			return;
		}

		set_sensitive TRUE $UI(prop_object_data) $UI(prop_object_name) $UI(prop_object_url)
		set current_object_url	[ac3d object_get_url $ob]

		set_object_data [ac3d object_get_data $ob]
		catch { $UI(object_data_message) configure -text "Editing object properties"}

		set obtype [ac3d object_get_type $ob]
	#puts "object type is $obtype"

#	puts "REFRESHING CURRENT RESOURCES"

		#remove all properties
		pack forget $UI(object_properties_frame) $UI(object_properties_frame2) $UI(object_data_frame)

		# add the core properties
		pack $UI(object_properties_frame) -side top -fill x

		if { $obtype == "poly" } {
			pack $UI(object_properties_frame2) -side top -fill x
		} else {
			pack forget $UI(object_properties_frame2)
		}
		pack $UI(object_data_frame) -fill both -expand 1

		if { $obtype != "poly" } {


		} else {
			set c [ac3d entity_get_value $ob "crease" ]
			#puts "crease $c"
			set CURRENT(crease_angle) $c
		}

		set loc [ ac3d entity_get_value $ob "loc" ]
		set CURRENT(loc_x) [lindex $loc 0]
		set CURRENT(loc_y) [lindex $loc 1]
		set CURRENT(loc_z) [lindex $loc 2]

		set sub  [ac3d entity_get_value $ob "subdivision_level"]
		set CURRENT(subdiv_level) $sub
	#	puts "subdiv level = $CURRENT(subdiv_level)"

	#set t [ac3d entity_get_class $ob ]
	#puts "entity class $t"

		set CURRENT(showname) [ ac3d entity_get_value $ob, "showname" ]


		set CURRENT(object) $ob


	}
}
